-- QUARTERS DRINKING GAME v1.0
-- Written for the PSP Lua Player
-- Written and Designed by SPASTIC:

-- Declare variables and initialize

-- Images
startscreen = Image.load("images/startscreen.png")
instructions = Image.load("images/instructions.png")
background = Image.load("images/background.png")
vBar = Image.load("images/sliderBarV.png")
hBar = Image.load("images/sliderBarH.png")
ball = Image.load("images/ball.png")
coinfull = Image.load("images/coinfull.png")
coin1 = Image.load("images/coin1.png")
coin2 = Image.load("images/coin2.png")
coin3 = Image.load("images/coin3.png")
coin4 = Image.load("images/coin4.png")
glass = Image.load("images/glass.png")
circleblank = Image.load("images/circleblank.png")
circlered = Image.load("images/circlered.png")
circlegreen = Image.load("images/circlegreen.png")
drink1 = Image.load("images/drink1.png")
drink2 = Image.load("images/drink2.png")
drink3 = Image.load("images/drink3.png")
miss = Image.load("images/miss.png")

-- Colors
green = Color.new(0, 255, 0)
red = Color.new(255, 0, 0)

-- Sounds
hit = Sound.load("sounds/hit.wav")
bounce = Sound.load("sounds/bounce.wav")

-- Variables
gameStart = true
gameInstructions = false

circle1 = circleblank
circle2 = circleblank
circle3 = circleblank
circleHit = false
circleMiss = false
turn = 0
turnEnd = false

score = 1
scoreAdd = false
misses = 0

vBallY = 33
vBallDown = true
vBallUp = false
hBallX = 83
hBallRight = true
hBallLeft = false

coinX = 42
coinY = 0
--coinSetX = 40
coinSetX = 42   
coinSetY = 40
coinDown = false
coinUp = false
coinMove = false
speedX = 1
speedY = 1

t = {coin1,coin2,coin3,coin4}
d = {miss,drink1,drink2,drink3}

coinPic = t[1]
pic = 0

time = 0

-- declare functions

    -- coin animation
function coinMotion()
        
    pic = pic + 1
    
    coinPic = t[pic]
       
    screen:blit(coinX, coinY, coinPic)
    
    if pic == 4 then
        pic = 0
    end
    
    -- coin behavior
    coinX = coinX + (coinSetX * .05)
 
    if coinDown == true then
        coinY = coinY + (coinY / 15);
        coinY = coinY + speedY;
        
        if coinY >= 200 then
            coinDown = false;
            coinUp = true;
            bounce:play()
        end
    end
    
    if coinUp == true then
        coinY = coinY - (coinY / 15);
        coinY = coinY - speedY;
        if coinY <= coinSetY then
            coinUp = false;
            coinDown = true
        end
    end
               
end

    
    -- height bar animation
function vBallMoveDown()
    vBallY = vBallY + 2
    if vBallY == 163 then
        vBallDown = false;
        vBallUp = true
    end
end

function vBallMoveUp()
    vBallY = vBallY - 2
    if vBallY == 23 then
        vBallUp = false;
        vBallDown = true
    end
end 
    
    -- length bar animation
function hBallMoveRight()
    hBallX = hBallX + 2
    if hBallX == 225 then
        hBallRight = false;
        hBallLeft = true
    end
end

function hBallMoveLeft()
    hBallX = hBallX - 2
    if hBallX == 83 then
        hBallLeft = false;
        hBallRight = true
    end
end    
    
-- start game loop
while true do
    -- Start Screen
    while gameStart == true do
        pad = Controls.read()        
        screen:blit(0, 0, startscreen)
        screen.flip()
        
        if pad:start() then
            gameStart = false;
            gameInstructions = true
        end
    end
    
    while gameInstructions == true do
        pad = Controls.read()
        screen:blit(0, 0, instructions)
        screen.flip()
        
        if pad:triangle() then
            gameInstructions = false
        end
    end    
    
    -- draw scene
    screen:blit(0, 0, background)
    screen:blit(15, 20, vBar)
    screen:blit(80, 240, hBar)
    screen:blit(18, vBallY, ball)
    screen:blit(hBallX, 243, ball)
    screen:blit(410, 170, glass)
    screen:blit(345, 15, circle1)
    screen:blit(385, 15, circle2)
    screen:blit(425, 15, circle3)
    
    -- read and react controls
    pad = Controls.read()
    
    if pad:square() and coinMove == false then
        coinSetY = vBallY;
        vBallUp = false;
        vBallDown = false;
        screen:blit(18, vBallY, ball)
    end
           
    if pad:cross() and coinMove == false then
        coinSetX = hBallX;
        hBallLeft = false;
        hBallRight = false;
        screen:blit(hBallX, 243, ball)
    end
    
    if pad:circle() and coinMove == false then
        coinMove = true;
        coinY = coinSetY;
        coinDown = true;
        coinHit = false
    end

    if coinMove == true then
        coinMotion();
        if coinX >= 480 then
            coinMove = false;
            coinX = 42;
            coinY = 40;
            vBallY = 23;
            hBallX = 83;
            vBallUp = false;
            vBallDown = true;
            hBallLeft = false;
            hBallRight = true;
            coinSetX = 42;
            coinSetY = 40;
            misses = misses + 1;
            turn = turn + 1;
            circleHit = false
        end
    end
    
    -- move objects
    if vBallDown == true then
        vBallMoveDown()
    end
        
    if vBallUp == true then
        vBallMoveUp()
    end
    
    if hBallRight == true then
        hBallMoveRight()
    end
    
    if hBallLeft == true then
        hBallMoveLeft()
    end
    
  
    -- perform game logic  
    
    if coinDown == true and (coinX > 410 and coinX < 430) and (coinY > 160 and coinY < 172) then
        scoreAdd = true
    end
    
    if scoreAdd == true then
        score = score + 1;
        scoreAdd = false;
        coinMove = false;
        coinX = 42;
        coinY = 0;
        vBallY = 23;
        hBallX = 83;
        vBallUp = false;
        vBallDown = true;
        hBallLeft = false;
        hBallRight = true;
        coinSetX = 42;
        coinSetY = 40;
        hit:play();
        circleHit = true;
        turn = turn + 1;
        if turnEnd == true then
            score = score - 1
        end
                
    end    
        
    if turn == 1 then
        if circleHit == true then
            circle1 = circlegreen
        end
        if circleHit == false then
            circle1 = circlered
        end
    end
    
    if turn == 2 then
        if circleHit == true then
            circle2 = circlegreen
        end
        if circleHit == false then
            circle2 = circlered
        end
    end
    
    if turn == 3 then
        if circleHit == true then
            circle3 = circlegreen;
            turnEnd = true
        end
        if circleHit == false then
            circle3 = circlered;
            turnEnd = true
        end
    end
    
    drinkPic = d[score]
    
    if turnEnd == true then
        screen:blit(100, 60, drinkPic);
                     
        if pad:triangle() then
            turn = 0;
            circle1 = circleblank;
            circle2 = circleblank;
            circle3 = circleblank;
            score = 1;
            misses = 0;
            turnEnd = false
        end
    end
    
    screen.waitVblankStart() 
    screen.flip()
    
-- end loop

    pad = Controls.read()
    if pad:select() then 
        break
    end
    
    if pad:start() then
        gameStart = true
    end
     
end
